#
# spec file for package backhand (Version 1.2.0)
# 
# Copyright  (c)  2001  SuSE GmbH  Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
# 
# please send bugfixes or comments to feedback@suse.de.
#

# neededforbuild  apache apache-devel autoconf automake java mm perl
# usedforbuild    aaa_base aaa_dir apache apache-devel autoconf automake base bash bindutil binutils bison bzip compress cpio cpp cracklib cyrus-sasl db devs diffutils e2fsprogs file fileutils findutils flex gawk gcc gdbm gdbm-devel gettext glibc glibc-devel gpm gppshare grep groff gzip java kbd less libtool libz m4 make man mktemp mm modutils ncurses ncurses-devel net-tools netcfg pam pam-devel patch perl ps rcs readline rpm sendmail sh-utils shadow strace syslogd sysvinit texinfo textutils timezone unzip util-linux vim

Name:         backhand
Copyright:    BSD-style, 1998-2001 The Johns Hopkins University
Group:        Networking/Daemons
Provides:     mod_backhand
Requires:     apache perl
Autoreqprov:  on
Version:      1.2.0
Release:      87
URL:	      http://www.backhand.org/
Icon:         mod_backhand.xpm
Summary:      Load balancing for the Apache web server
Source:       mod_%{name}-%{version}.tar.bz2

%description
What is mod_backhand?
mod_backhand is project that allows seamless redirection of HTTP
requests from one web server to another. This redirection can be used
to target machines with under-utilized resources, thus providing
fine-grained, per-request load balancing of web requests.
Backhand is a project that was initiated in class at The Johns Hopkins
University in The Department of Computer Science. After a simple proof
of concept, written in C++, the project was pursued as a graduate
qualifier project.
A proof of concept was realized, but a deployable product was
needed. In order for public use, testing and, ultimately, acceptance,
we wished to provide drop-in functionality in the most popular web
server on the net.
mod_backhand was born. This drop-in module for the Apache Web Server
provides a turnkey solution for intra-cluster redirection of HTTP on a
per-request basis. The redirection is based on various system
resources available within the cluster. This service is provided
seamlessly, preserving remote host information for
access/authentication purposes. As with the methodology of Apache, the
redirection mechanism can be enabled or disable for individual
directories.
System resources are announced by the module to the cluster via
ethernet broadcasts and/or IP multicasts. These resources are made
available to the decision making algorithms that drive mod_backhand.

Authors:
--------
    Yair Amir <yairamir@cs.jhu.edu>
    Theo Schlossnagle <jesus@omniti.com>
    Baruch Awerbuch <baruch@cs.jhu.edu>
    Ryan Borgstrom <rsean@cs.jhu.edu>

SuSE series: n

%prep 
%define apache_libexecdir %(apxs -q LIBEXECDIR)
%define apache_docroot    %(apxs -q PREFIX)/htdocs
%define apache_sysconfdir %(apxs -q SYSCONFDIR)
%setup -n mod_backhand-%{version}

%build
autoconf
./configure --with-apxs=`which apxs` %{_target_cpu}-suse-linux
apxs -c -o mod_backhand.so apue.c arriba.c back_util.c builtins.c mod_backhand.c
apxs -c -o byHostname.so   byHostname.c
strip *.so

%install
apxs -i mod_backhand.so
apxs -i -n byHostname.c byHostname.so
install -m 644 *.jpg %{apache_docroot}
install -d -m 744 -o wwwrun /var/lib/backhand
echo "#" > apache.rc.config
echo "# enable the Backhand module (yes|no)" >> apache.rc.config
echo "#" >> apache.rc.config
echo "HTTPD_SEC_MOD_BACKHAND=no" >> apache.rc.config
echo ""  >> apache.rc.config
echo -e "Variable:HTTPD_SEC_MOD_BACKHAND\nLoadModule:LoadModule backhand_module %{apache_libexecdir}/mod_backhand.so\nAddModule:AddModule mod_backhand.c\nText:Backhand\n" \
        > %{apache_sysconfdir}/modules/mod_backhand
install -m 644 apache.rc.config %{_var}/adm/fillup-templates/apache-mod_backhand.rc.config
%{_sbindir}/httpd -t || exit 1

%post
echo -n "Updating etc/rc.config.d/apache.rc.config..."
if [ -x bin/fillup ] ; then
        test -e etc/rc.config.d/apache.rc.config || touch etc/rc.config.d/apache.rc.config
        bin/fillup -q -d = etc/rc.config.d/apache.rc.config var/adm/fillup-templates/apache-mod_backhand.rc.config
        echo " Done."
else
        echo
        echo "ERROR: fillup not found. This should not happen. Please compare"
        echo "etc/rc.config.d/apache.rc.config and "
        echo "var/adm/fillup-templates/apache-mod_backhand.rc.config and update by hand."
fi

%files 
%doc INSTALL LICENSE ChangeLog NOTICE *.jpg
%{apache_libexecdir}/mod_backhand.so
%{apache_libexecdir}/byHostname.so
%attr(0744,wwwrun,root) %dir /var/lib/backhand
%{apache_docroot}/backhand.jpg 
%{apache_docroot}/cndsbar_mini.jpg 
%{apache_docroot}/mod_backhand_mini.jpg
%{_var}/adm/fillup-templates/apache-mod_backhand.rc.config
%{apache_sysconfdir}/modules/mod_backhand

%changelog -n backhand
* Wed Aug 22 2001 - poeml@suse.de
- use /var/lib/backhand instead of /var/state/backhand for unix
  domain sockets (more FHS compliant)
* Fri Jun 08 2001 - rolf@suse.de
- update to version 1.2.0
- use configure and autoconf
- added /etc/httpd/modules/mod_backhand
- bzip2 sources
* Fri Feb 23 2001 - ro@suse.de
- changed neededforbuild <apache> to <apache apache-devel>
* Thu Sep 07 2000 - rolf@suse.de
- update to version 1.1.0
- fix permissions to /var/state/backhand directory
* Thu Apr 13 2000 - ro@suse.de
- added mm to neededforbuild
* Thu Mar 16 2000 - rolf@suse.de
- RPM package build, version 1.0.8
